#ifndef _USER_H
#define _USER_H

#include "Common.h"
#include "Character.h"
#include <string>
#include <memory>
#include <vector>
using namespace std;

class User {
	private:
	uint id;
	uint characters[4]; //array of User characters id
	unique_ptr<Character> current; //current char

	User(uint id);
	public:
	//return a vector of char for the selection screen
	vector< unique_ptr<Character> > LoadCharacters();

	// login, return users. NULL if fails to login
	static unique_ptr<User> Login(const string& nikname, const string& password);

	//find user id for user with a specifi username. 0 if not founded
	static uint FindUserID(const string& nikname);

	uint GetID() { return id; }
	Character * GetCurrentCharacter() { return current.get(); }

	destructor User() { current = NULL; }
};

#endif