/*
	Lego Universe Authentification Server WIP
	Code done by humanoid24 (aka Triver) as of 01.12.2013
	additional credits to raffa50 30.01.2013 for MySql and improvements

	This source code requires RakNet version 3.25 as
	an external dependency to work with the luni client.
	the source is open and free and all trademarks are of their respective owners
	*/

#include "Common.h"
#include "serverLoop.h"
#include "Database.h"
#include "User.h"
#include "IniReader.h"
#include "Kbhit.h"

#define _CRT_SECURE_NO_WARNINGS

#include <fstream>
#include <thread>

using namespace std;

void LoadConfig(CONNECT_INFO& auth, CONNECT_INFO& character, CONNECT_INFO& world) {
	CIniReader iniReader(".\\config.ini");
	strcpy(auth.redirectIp, iniReader.ReadString("Settings", "redirect_ip", "127.0.0.1"));
	strcpy(character.redirectIp, auth.redirectIp);
	strcpy(world.redirectIp, auth.redirectIp);

	auth.useEncryption = character.useEncryption = world.useEncryption = iniReader.ReadBoolean("Settings", "use_encryption", false);
	auth.logFile = character.logFile = world.logFile = iniReader.ReadBoolean("Settings", "log_file", true);

	auth.redirectPort = iniReader.ReadInteger("Auth", "redirect_port", 2002);
	auth.listenPort = iniReader.ReadInteger("Auth", "listen_port", 1001);

	character.redirectPort = iniReader.ReadInteger("Char", "redirect_port", 2003);
	character.listenPort = iniReader.ReadInteger("Char", "listen_port", 2002);

	world.redirectPort = iniReader.ReadInteger("World", "redirect_port", 2004);
	world.listenPort = iniReader.ReadInteger("World", "listen_port", 2003);
}

void QuitError(const string& msg = "") {
	cout << "Terminated " << msg << endl << "PRESS ENTER TO QUIT" << endl;
	while (!_kbhit());
	exit(1);
}

//allocate binary file in memory and return pointer, NULL if fails
void * AllocBin(const string& filename, uint* size = NULL) {
	ifstream file(filename, ios::in | ios::binary | ios::ate);
	if (!file.is_open()) return NULL;

	int fsz = file.tellg();
	if (size != NULL) *size = fsz;
	file.seekg(0, ios::beg);

	void * r = malloc(fsz);
	if (r == NULL) { 
		if (size != NULL) *size = 0;
		return NULL; 
	}

	file.read((char*)r, fsz);
	file.close();

	return r;
}

int main() {
	cout << "Initializing LUNI test server...\n";
	CONNECT_INFO auth, character, world;
	LoadConfig(auth, character, world);
	cout << "Loaded config!\n";

	try {
		Database::Connect();
	}
	catch (MySqlException& ex) {
		QuitError(ex.what());
	}

	cout << "Connected to mysql database!\n\n";

	{
		uint size;
		PacketCharacter * pk = (PacketCharacter*) AllocBin(".\\char\\char_aw2.bin", &size);
		Character * c = pk->characters;
		if (pk != NULL) {
			cout << endl << RawDataToString((uchar*)c, sizeof(Character)*1) << endl;
			for (uint i = 0; i < 4; i++) {
				cout << endl << c[i].GetName() << endl << RawDataToString( c[i].GetRawName(), MAXCHARNAMELEN ) << endl;
			}

			cout << "\nThere are " << (size - sizeof(PacketCharacter)) << " bytes remainders\n\n";

			delete pk;
		} else cout << "failure!\n";
	}


	thread thauth(listenForPackets, &auth, "auth");
	thread thchar(listenForPackets, &character, "char");
	thread thworld(listenForPackets, &world, "world");

	bool quit = false;
	while (!quit) {
		if (_kbhit()) { //parsing server commands. press enter to start writing a command (may need to lock consoleoutmutex...)
			string command;
			cout << "> ";
			cin >> command;
			cout << endl;
			if (command == "help") cout << "\nAviable commands: \nquit = quit the server \nregister = register new user\n";
			else if (command == "quit") quit = LUNIterminate = true;
			else if (command == "register") {
				string username, password;
				cout << "Username: ";
				cin >> username;
				if (User::FindUserID("") == 0) {
					cout << "Password: ";
					cin >> password;
					Database::Query("INSERT INTO `accounts` (`id`, `name`, `password`, `email`, `ip`, `rank`, `lastLog`, `activeSub`, `subTime`, `legoClub`) VALUES (NULL, '" + username + "', '" + password + "', '', '127.0.0.1', '0', CURRENT_TIMESTAMP, '0', '', '');");
				} else cout << "Username already exist!\n";

			} else cout << "invalid command: " << command << endl;
		}
	}

	/*thauth.join();
	thchar.join();
	thworld.join();*/

	/*} else {
		string quitMsg = "Failed to initialize the server, exiting...\n";
		msgFileHandler.WriteLog(quitMsg.c_str());
		QuitError(quitMsg);
		}

		rakServer->Shutdown(0);
		RakNetworkFactory::DestroyRakPeerInterface(rakServer);*/
	exit(0);
}
